#include <amxmodx>
#include <amxmisc>

new name_receiver[33], receivers[256], user_fm[33],count
static buffer[4096], buffer_off[2048]

/*
От автора: 

*За основу взят плагин от SLIMSHADY © версии 2.0
*3.0 Версия онлайн радио
*Все станции работают
*авто Bind на кнопку F3
*Цвет DHUDa Зелёный
*Информер справа сверху
*Плагин by AWPIIIHI/IK v3.0
*/

/*
Для того, чтобы добавить свою станцию, добавьте строчку в массив ниже.
На примере других станций, в формате: {"Название","Ссылка на потоковое вещание"},
Учтите, что если добавляете станцию в самый конец, то запятая в конце строки не нужна.
Желательно, чтобы станции были вида: "ссылка.m3u"
*/

new const fm_id[][][] = 
{ 
{"",""}, /*Для удобства оставляем первую строчку пустой, удалять ее не нужно.*/

{"90s Eurodance",             "http://listen1.myradio24.com:9000/5967"},
{"Жулдыз ФМ",             "http://91.201.214.229:8000/zhulduz"},
{"Авторадио Казахстан",             "http://95.56.234.40:8080/AVTORADIO"},
{"Русское Радио Азия",             "http://31.148.22.35:9000/stream"},
{"Radio NS",             "http://89.219.35.26:8000/radions"},
{"Energy FM",             "http://89.219.34.117:8008/NEWENERGY"},
{"Юмор FM Казахстан",             "http://s0.radioheart.ru:8000/RH41924"},
{"DALA FM",             "http://95.56.234.40:8080/DALA_128"}
}

/*Функция для отображения списка слушателей.*/
public who()
{
/*Настройка цвета и позиции для сообщения.*/
set_hudmessage(0, 255, 0, 0.84, 0.20, 2, 0.04, 30.0, 0.03, 0.02, 1)

/*Если слушателей нет, то показываем это сообщение.*/
if(!name_receiver[0])
show_hudmessage(0, "Играй с музыкой! =)^nНапиши /fm в чат.")

/*Если есть, то это.*/
else
show_hudmessage(0, "Играй с музыкой! =)^nНапиши /fm в чат.^nСлушатели:^n%s", receivers)

}

public fm(id)
{
new i_Menu = menu_create("\yServerRadio:","radio")
new item[3], form[64]

/*Составляем пункты меню из списка станций.*/
for(new i=1; i<=count; i++)
{
num_to_str(i, item, 3)

/*Если текущая станция - проигрываемая, то указываем это.*/
if(i==user_fm[id])
{
formatex(form, charsmax(form), "\d%s (now)", fm_id[i][0])
menu_additem(i_Menu, form, item,0)
}
/*Если нет, то обычная строка.*/
else
menu_additem(i_Menu, fm_id[i][0], item)
}

/*Русификация пунктов: Back, Next, Exit.*/
menu_setprop(i_Menu, MPROP_NEXTNAME, "\yДалее")
menu_setprop(i_Menu, MPROP_BACKNAME, "\yНазад")
menu_setprop(i_Menu, MPROP_EXITNAME, "\yГл. меню")
menu_setprop(i_Menu, MPROP_EXIT, MEXIT_ALL)
menu_display(id, i_Menu, 0)
return PLUGIN_HANDLED
}

/*Биндим кнопку на включение радио*/
public client_authorized(id)
{
client_cmd(id, "bind ^"F3^" ^"say /fm^"")
}

public client_disconnect(id)
{
if(user_fm[id])
{
user_fm[id] = 0
hudradio();
}
}

/*Функция для пересчета слушателей и прослушиваемых станций.*/
public hudradio()
{
name_receiver[0] = '^0';
receivers[0] = '^0';
new num=get_maxplayers()
for(new id = 1; id <= num; id++)
{ 
if(!is_user_connected(id) || !user_fm[id])
continue;
get_user_name(id, name_receiver, 31)
formatex(receivers, 255, "%s %s (%s)^n", receivers, name_receiver, fm_id[user_fm[id]][0])
}
}
  
/*Основное меню плагина*/
public fm_menu(id)
{
new i_Menu

if(user_fm[id] > 0)
{
i_Menu = menu_create_format("\yServerRadio^n\wВы слушаете: \y%s", "radiod", fm_id[user_fm[id]][0])
menu_additem(i_Menu, "\yОтключить" , "1", 0)
menu_additem(i_Menu, "Случайная станция", "3", 0)
menu_additem(i_Menu, "\wСписок станций", "2", 0)	
}

else
{
i_Menu = menu_create("\yServerRadio", "radiod")
menu_additem(i_Menu, "\yСлучайная станция", "1", 0)
menu_additem(i_Menu, "\wСписок станций", "2", 0)
}

menu_additem(i_Menu, "Слушатели", "4", 0)

/*Русификация пунктов: Back, Next, Exit.*/
menu_setprop(i_Menu, MPROP_NEXTNAME, "\yДалее")
menu_setprop(i_Menu, MPROP_BACKNAME, "\yНазад")
menu_setprop(i_Menu, MPROP_EXITNAME, "\rВыйти")
menu_setprop(i_Menu, MPROP_EXIT, MEXIT_ALL)

menu_display(id, i_Menu, 0)

return PLUGIN_HANDLED
}
public radiod(id, menu, item)
{ 
if (item == MENU_EXIT)
{
menu_destroy(menu)
return PLUGIN_HANDLED
}
new s_Data[6], s_Name[64], i_Access, i_Callback
menu_item_getinfo(menu, item, i_Access, s_Data, charsmax(s_Data), s_Name, charsmax(s_Name), i_Callback)
new i_Key = str_to_num(s_Data)
switch(i_Key)
{
case 1:
{

if(user_fm[id] > 0)
{
user_fm[id] = 0
hudradio();Play(id)
}

else
random_fm(id)

}
case 2:fm(id)
case 3:random_fm(id)
case 4:
{
set_hudmessage(0, 255, 0, 0.84, 0.20, 2, 0.04, 30.0, 0.03, 0.02, 1)

if(!name_receiver[0])
show_hudmessage(id, "Слушателей нет :'(")
else
show_hudmessage(id, "Слушатели:^n%s", receivers)
}	
}
menu_destroy(menu)
return PLUGIN_HANDLED
}
 
public Play(id)
{

static motd_show[4096]

/*Если клиент предпочел выключить радио.*/
if(!user_fm[id]) show_motd(id, buffer_off, "OFF")

/*Если включил или выбрал другую станцию.*/
else
{
formatex(motd_show, charsmax(motd_show), buffer, fm_id[user_fm[id]][0], fm_id[user_fm[id]][1])
show_motd(id, motd_show, "СЕРВЕР РАДИО")
}

}

public radio(id, menu, item)
{  
if (item == MENU_EXIT)
{
menu_destroy(menu)
fm_menu(id)
return PLUGIN_HANDLED
}

new s_Data[6], s_Name[64], i_Access, i_Callback
menu_item_getinfo(menu, item, i_Access, s_Data, charsmax(s_Data), s_Name, charsmax(s_Name), i_Callback)
user_fm[id] = str_to_num(s_Data)
Play(id);hudradio()
menu_destroy(menu)

return PLUGIN_HANDLED
}

/*Функция для случайного выбора станции.*/
public random_fm(id)
{
new random_int = random_num(1, count);
/*Если случайное радио совпадает с текущей проигрываемой станцией, то выбираем случайное еще раз.*/
if(random_int == user_fm[id])
{
random_fm(id); return PLUGIN_HANDLED	
}
user_fm[id] = random_int;
Play(id);hudradio();
return PLUGIN_HANDLED
}


public plugin_init() 
{	
register_plugin("ServerRadio", "3.0", "AWPIIIHI/IK")

/*Команда для вызова меню плагина.*/
register_clcmd("say /fm", "fm_menu")

/*Регистрация квара для регулировки показа информации о слушателях.*/
new cvar = register_cvar("amx_miniradio_showtime", "100.0")
/*Узнаем общее кол-во FM станций.*/
count = sizeof(fm_id)-1

/*
Формируем окно включения радио
Если хотите добавить строчку пишите через add(buffer, charsmax(buffer), "Ваша строка")

Основные переменные:
<body bgcolor='black'> - цвет фона (аналогично со шрифтом)
<div align='center'>Текст</div> - строка по центру
<div align='left'>Текст</div> - строка влево
<div align='right'>Текст</div> - строка вправо
<font color='grey'>Текст</font> - цвет текста серый
<font color='white'>Текст</font> - цвет текста белый
<font color='green'>Текст</font> - цвет текста зелёный
<font color='yellow'>Текст</font> - цвет текста жёлтый
<font color='red'>Текст</font> - цвет текста красный
<font color='blue'>Текст</font> - цвет текста синий
<big>Текст</big> - большие букофки
<b>Текст</b> - жирный шрифт
<br> - перевод строки
*/
add(buffer, charsmax(buffer), "<meta http-equiv='Content-Type' content='text/html; charset=Utf-8'><p align='center'><body bgcolor='black'>")
add(buffer, charsmax(buffer), "<div align='left'><big><font color='grey'><b>ServerRadio v3.0</b></big></br>")
add(buffer, charsmax(buffer), "<br><div align='left'><font color='white'><b>...Вы слушаете радио: <font color='grey'>%s.</b></font></br>")
add(buffer, charsmax(buffer), "<div align='left'><font color='white'><b>...Идёт загрузка буфера, вы можете закрыть окно нажав ОК.</b></font></br>")
add(buffer, charsmax(buffer), "<div align='left'><font color='white'><b>...Если станция не работает, попробуйте включить её снова.</b></font>")
add(buffer, charsmax(buffer), "<DIV align=center><EMBED style='WIDTH: 298px; HEIGHT: 100px' height=500 type=application/x-mplayer2 pluginspage=http://www.microsoft.com/windows/mediaplayer/ width=500 src='%s' ShowStatusBar='1' showtracker='0'")
add(buffer, charsmax(buffer), "displaysize='0' autosize='1' showcontrols='true' Volume='10' animationatstart='0' transparentatstart='0' autostart='true'></DIV></body>")
add(buffer, charsmax(buffer), "</br></br><div align='left'><font color='white'><b>...Надеюсь вам понравилось радио и вы получили удовольствие от музыки.</b></font><br>")
add(buffer, charsmax(buffer), "<div align='left'><font color='white'><b>...Если вы хотите установить себе на сервер это радио, обращайтесь в VK: fanatcs1</b></font>")


/*Формируем окно выключения радио.*/
add(buffer_off, charsmax(buffer_off), "<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'><title>play</title></head><body bgcolor='black'><p align='center'>")
add(buffer_off, charsmax(buffer_off), "<div align='left'><big><b><font color='grey'>ServerRadio v3.0</br></div>")
add(buffer_off, charsmax(buffer_off), "<div align='left'><font color='red'><b>...Воспроизведение радио выключено.</font></b></big></br>")
add(buffer_off, charsmax(buffer_off), "</br></br><div align='left'><font color='white'><b>...Надеюсь вам понравилось радио и вы получили удовольствие от музыки.</b></font><br>")
add(buffer_off, charsmax(buffer_off), "<div align='left'><font color='white'><b>...Если вы хотите установить себе на сервер это радио, обращайтесь в VK: fanatcs1</b></font>")

/*Таймер для показа информации о слушателях.*/
if(get_pcvar_float(cvar)>0.0)
set_task(get_pcvar_float(cvar),"who", random_num(100, 600), _, _,"b")

}

/*Функция для быстрого форматирования заголовка.*/
stock menu_create_format(const title[], const handler[], any:...)
{
new menu_title[256]
vformat(menu_title, charsmax(menu_title), title, 3)
return menu_create(menu_title, handler);
}
/*
The End. August 2013
*/
